# core/defines.py
#
#

""" defines. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

import string
import socket
import os.path
import os
import re

## RUNTIME

homedir = os.path.expanduser("~") 
curdir = os.getcwd()
try: hostname = socket.getfqdn()
except: hostname = "localhost" 
port = 10102

## CONSTANTS

leapfactor = float(6*60*60)/float(365*24*60*60)

daylist = ["Date", "path"]

# Sat, 13 Oct 2012 11:18:45 -0700 (PDT)

dayformats = ["%Y-%m-%d %H:%M:%S", "%a, %d %m %Y %H:%M:%S", "%a, %d %m %Y %H:%M:%S %s (%s)", "%Y-%m-%d %H:%M:%S", "%Y-%m-%d", "%d-%m-%Y"]
dayshorts =  ["%H:%M:%S", "%H:%M"]
short_day = "(%s %s %s %s:%s:%s)"

basic_types= [ str, int, float, bool, None]

attributes = {}
subelements = {}

attributes['message'] = ['type', 'from', 'to', 'id']
subelements['message'] = ['subject', 'body', 'error', 'thread', 'x']

attributes['presence'] = ['type', 'from', 'to', 'id']
subelements['presence'] = ['show', 'status', 'priority', 'x']


attributes['iq'] = ['type', 'from', 'to', 'id']
subelements['iq'] = ['query', 'error']

allowedchars = string.ascii_letters + string.digits + "_,-. \n" + string.punctuation
allowednamechars = string.ascii_letters + string.digits + '!.@'

## COLORS

ERASE_LINE = '\033[2K'
BOLD='\033[1m'
GRAY='\033[99m'
RED = '\033[91m'
YELLOW = '\033[93m'
GREEN = '\033[92m'
BLUE = '\033[94m'
BLA = '\033[95m'
ENDC = '\033[0m'

## URLS

re_url_match  = re.compile('((?:http|https)://\S+)')
