# core/plugs/write.py
#
#

""" storage. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from core.kernel import kernel
from core.thing import Thing

## CMNDS

def db_rm(event):
    try: key, match = event.parsed.rest.split(" ", 1)
    except ValueError: return
    nr = 0
    for fn in kernel.all(key):
        obj = Thing().load(fn)
        if key not in obj: continue
        if match not in obj[key]: continue
        obj.deleted = True
        obj.sync()
        nr += 1
    event.ok(nr)

kernel.register("db.rm", db_rm)

def db_restore(event):
    try: key, match = event.parsed.args
    except ValueError: return
    nr = 0
    for fn in kernel.all(*event.parsed.args):
        obj = Thing().load(fn)
        if key not in obj: continue
        if match not in obj[key]: continue
        if "deleted" not in obj: continue
        obj.deleted = False
        obj.sync()
        nr += 1
    event.ok(nr)

kernel.register("db.restore", db_restore)
