# core/dutch/clock.py
#
#

""" time the timing. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from core.utils.time import get_day, get_hour, today, short_date
from core.clock import Timer
from core.kernel import kernel
from core.thing import Thing

import time

## COMMANDS

def clock_timer(event):
    rest = event.parsed.rest
    if not rest: return
    day = get_day(rest) or today()
    hour = get_hour(rest)
    target = day + get_hour(rest)
    event.reply("time found: %s" % short_date(time.ctime(target)))
    t = Thing()
    t.service = "clock"
    t.prefix = "timer"
    t.time = target
    t.save()
    timer = Timer(target, event)
    kernel.put(timer.start)
    event.ok()

kernel.register("clock.timer", clock_timer)

def init():
    last_timer = kernel.last("prefix", "timer")
    if not last_timer: return
    if time.time() > int(last_timer.time): return
    timer = Timer(int(last_timer.time), kernel)
    kernel.put(timer.start)
